Debian Bug report logs - #557580
aptitude does not obey pins in preferences.d/*

version graph

Package: aptitude; Maintainer for aptitude is Aptitude Development Team <aptitude-devel@lists.alioth.debian.org>; Source for aptitude is src:aptitude.

Reported by: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

Date: Mon, 23 Nov 2009 01:18:01 UTC

Severity: serious

Tags: patch

Merged with 571312

Found in versions aptitude/0.6.1.3-3, aptitude/0.6.1.5-2, aptitude/0.6.1.5-3

Fixed in version aptitude/0.6.3-3.2

Done: Tim Retout <diocles@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Daniel Burrows <dburrows@debian.org>:
Bug#557580; Package aptitude. (Mon, 23 Nov 2009 01:18:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Kahn Gillmor <dkg@fifthhorseman.net>:
New Bug report received and forwarded. Copy sent to Daniel Burrows <dburrows@debian.org>. (Mon, 23 Nov 2009 01:18:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
To: submit@bugs.debian.org
Subject: aptitude accepts /etc/apt/preferences but ignores /etc/apt/preferences.d/*
Date: Sun, 22 Nov 2009 20:20:11 -0500
[Message part 1 (text/plain, inline)]
Subject: aptitude accepts /etc/apt/preferences but ignores /etc/apt/preferences.d/*
Package: aptitude
Version: 0.6.1.3-3
Severity: normal

On a mixed sid/testing system, the same text behaves differently whether
placed in /etc/apt/preferences or in /etc/apt/preferences.d/pinning.

apt-get respects files placed in either location, and apt-cache policy 
also shows the expected behavior.  aptitude alone behaves this way.

I saw the same behavior on version 0.4.11.11-1+b2, and tried upgrading 
to 0.6.1.3-3 to see if it was fixed in sid, but the misbehavior remains.

below is an example transcript showing the misbehavior.

0 attica:~# apt-cache policy libxapian15                                        
libxapian15:
  Installed: 1.0.16-3
  Candidate: 1.0.16-3
  Version table:
     1.0.17-1 0
        200 http://ftp.us.debian.org sid/main Packages
 *** 1.0.16-3 0
        500 http://ftp.us.debian.org squeeze/main Packages
        100 /var/lib/dpkg/status
0 attica:~# cat /etc/apt/preferences
Package: *
Pin: release a=unstable
Pin-Priority: 200
0 attica:~# mv /etc/apt/preferences /etc/apt/preferences.d/pinning
0 attica:~# apt-cache policy libxapian15                                        
libxapian15:
  Installed: 1.0.16-3
  Candidate: 1.0.16-3
  Version table:
     1.0.17-1 0
        200 http://ftp.us.debian.org sid/main Packages
 *** 1.0.16-3 0
        500 http://ftp.us.debian.org squeeze/main Packages
        100 /var/lib/dpkg/status
0 attica:~# aptitude full-upgrade
Reading package lists... Done
Building dependency tree       
Reading state information... Done
Reading extended state information... Done
Initializing package states... Done       
Reading task descriptions... Done  
The following packages are BROKEN:
  esound-common libesd-alsa0 libesd0 linux-image-2.6-powerpc 
The following NEW packages will be installed:
  dash{a} keyboard-configuration{a} libffi-dev{a} libgsl0ldbl{a} 
  liblzma0{a} liblzma1{a} libmagickcore2-extra{a} libmozjs2d{a} 
  libneon27-gnutls{a} libpoppler5{a} rpm-common{a} rpm2cpio{a} 
The following packages will be REMOVED:                                         
  haskell-utils{u} libmozjs1d{u} libncurses5-dev{u} libneon27{u}                
  libpoppler4{u} libreadline5-dev{u} xulrunner-1.9{u}                           
The following packages will be upgraded:                                        
  apt-utils bash bsdmainutils console-setup console-terminus consolekit         
  coreutils cpp cpp-4.3 cups cups-client cups-common debianutils defoma         
  devscripts dpkg dpkg-dev esound-clients fakeroot fbset foomatic-db-engine     
  gcc gcc-4.3 gcc-4.3-base gcc-4.4-base ghc6 gimp gimp-data gnome-keyring       
  gvfs iceweasel imagemagick inkscape libboost-iostreams1.40.0                  
  libck-connector0 libcups2 libcupscgi1 libcupsdriver1 libcupsimage2            
  libcupsmime1 libcupsppdc1 libcwidget3 libdb4.5 libeggdbus-1-0                 
  libenchant1c2a libevent-1.4-2 libexif12 libgcc1 libgcr0 libgdbm3              
  libgfortran3 libgimp2.0 libgirepository1.0-0 libgnome-keyring0                
  libgnome2-0 libgnome2-common libgnutls26 libgomp1 libgp11-0 libgraphviz4      
  libgstreamer-plugins-base0.10-0 libgstreamer0.10-0 libmagick++2               
  libmagickcore2 libmagickwand2 libmysqlclient16 libnautilus-extension1         
  libpam-ck-connector libpam-gnome-keyring libpango1.0-0 libpango1.0-common     
  libperl5.10 libpolkit-gobject-1-0 libpoppler-glib4 librpm0 librpmbuild0       
  librpmio0 libsasl2-2 libsasl2-modules libsepol1 libssl0.9.8 libstdc++6        
  libudev0 libv4l-0 libvte-common libvte9 libxapian15 libxmmsclient-glib1       
  libxmmsclient5 ltrace lxde lxde-common lxde-core manpages manpages-dev        
  manpages-fr manpages-fr-dev mysql-common nano openoffice.org-common           
  openoffice.org-core openoffice.org-gtk openoffice.org-style-crystal           
  openoffice.org-style-galaxy openoffice.org-style-oxygen                       
  openoffice.org-style-tango openssl p7zip-full perl perl-base perl-modules     
  perlmagick pm-utils poppler-utils psfontmgr python-central                    
  python-gtkhtml2 python-pyorbit python2.5 python2.5-minimal rpm                
  ttf-opensymbol tzdata ucf udev uno-libs3 ure xmms2-core xmms2-plugin-alsa     
  xmms2-plugin-id3v2 xmms2-plugin-mad xmms2-plugin-vorbis                       
  xserver-xorg-input-synaptics                                                  
The following packages are RECOMMENDED but will NOT be installed:               
  at bash-completion bsd-mailx build-essential bzr cvs cvsnt dctrl-tools        
  debian-keyring debian-maintainers dput dupload equivs git-core                
  heirloom-mailx libauthen-sasl-perl libcrypt-ssleay-perl                       
  libparse-debcontrol-perl libsoap-lite-perl libterm-size-perl libwww-perl      
  libyaml-syck-perl lintian lsb-release mailutils mercurial patchutils          
  subversion svk tla wdiff                                                      
135 packages upgraded, 15 newly installed, 7 to remove and 0 not upgraded.      
Need to get 250MB of archives. After unpacking 13.9MB will be used.             
The following packages have unmet dependencies:                                 
  libesd-alsa0: Conflicts: libesd0 but 0.2.41-6 is to be installed.             
  esound-common: Conflicts: libesd-alsa0 but 0.2.41-5 is installed.             
  libesd0: Conflicts: libesd-alsa0 but 0.2.41-5 is installed.                   
  linux-image-2.6-powerpc: Depends: linux-image-2.6.31-1-powerpc which is a virt
ual package.                                                                    
The following actions will resolve these dependencies:

Keep the following packages at their current version:
esound-clients [0.2.41-5 (testing, now)]
esound-common [0.2.41-5 (testing, now)]
libesd0 [Not Installed]
linux-image-2.6-powerpc [2.6.30+21 (testing, now)]

Tier: Safe actions (10000)

Accept this solution? [Y/n/q/?] q
Abandoning all efforts to resolve these dependencies.
Abort.
0 attica:~# mv /etc/apt/preferences.d/pinning /etc/apt/preferences
0 attica:~# aptitude full-upgrade                                               
Reading package lists... Done
Building dependency tree       
Reading state information... Done
Reading extended state information... Done
Initializing package states... Done       
Reading task descriptions... Done  
No packages will be installed, upgraded, or removed.
0 packages upgraded, 0 newly installed, 0 to remove and 0 not upgraded.
Need to get 0B of archives. After unpacking 0B will be used.
Reading package lists... Done
Building dependency tree       
Reading state information... Done
Reading extended state information... Done
Initializing package states... Done       
Reading task descriptions... Done  

0 attica:~# 


here's plain ol' apt-get behaving properly:

1 attica:~# apt-get dist-upgrade
Reading package lists... Done
Building dependency tree       
Reading state information... Done
Calculating upgrade... Done
The following NEW packages will be installed:
  dash
0 upgraded, 1 newly installed, 0 to remove and 0 not upgraded.
Need to get 101kB of archives.
After this operation, 250kB of additional disk space will be used.
Do you want to continue [Y/n]? n
Abort.
1 attica:~# mv /etc/apt/preferences /etc/apt/preferences.d/pinning
0 attica:~# apt-get dist-upgrade                                                
Reading package lists... Done
Building dependency tree       
Reading state information... Done
Calculating upgrade... Done
The following NEW packages will be installed:
  dash
0 upgraded, 1 newly installed, 0 to remove and 0 not upgraded.
Need to get 101kB of archives.
After this operation, 250kB of additional disk space will be used.
Do you want to continue [Y/n]? n
Abort.
1 attica:~# 

Thanks for maintaining aptitude!

	--dkg


-- Package-specific info:
aptitude 0.6.1.3 compiled at Nov 20 2009 20:16:43
Compiler: g++ 4.3.4
Compiled against:
  apt version 4.8.1
  NCurses version 5.7
  libsigc++ version: 2.0.18
  Ept support enabled.
  Gtk+ support disabled.

Current library versions:
  NCurses version: ncurses 5.7.20090803
  cwidget version: 0.5.13
  Apt version: 4.8.1
	linux-vdso32.so.1 =>  (0x00100000)
	libapt-pkg-libc6.9-6.so.4.8 => /usr/lib/libapt-pkg-libc6.9-6.so.4.8 (0x0feff000)
	libncursesw.so.5 => /lib/libncursesw.so.5 (0x0fe8e000)
	liblog4cxx.so.10 => /usr/lib/liblog4cxx.so.10 (0x0fc76000)
	libsigc-2.0.so.0 => /usr/lib/libsigc-2.0.so.0 (0x0fc4f000)
	libcwidget.so.3 => /usr/lib/libcwidget.so.3 (0x0fb57000)
	libept.so.0 => /usr/lib/libept.so.0 (0x0fab0000)
	libxapian.so.15 => /usr/lib/libxapian.so.15 (0x0f908000)
	libz.so.1 => /usr/lib/libz.so.1 (0x0f8d3000)
	libsqlite3.so.0 => /usr/lib/libsqlite3.so.0 (0x0f81c000)
	libboost_iostreams.so.1.40.0 => /usr/lib/libboost_iostreams.so.1.40.0 (0x0f7ef000)
	libpthread.so.0 => /lib/libpthread.so.0 (0x0f7b5000)
	libstdc++.so.6 => /usr/lib/libstdc++.so.6 (0x0f669000)
	libm.so.6 => /lib/libm.so.6 (0x0f59b000)
	libgcc_s.so.1 => /lib/libgcc_s.so.1 (0x0f560000)
	libc.so.6 => /lib/libc.so.6 (0x0f3d1000)
	libutil.so.1 => /lib/libutil.so.1 (0x0f3ae000)
	libdl.so.2 => /lib/libdl.so.2 (0x0f38a000)
	libaprutil-1.so.0 => /usr/lib/libaprutil-1.so.0 (0x0f343000)
	libapr-1.so.0 => /usr/lib/libapr-1.so.0 (0x0f2e2000)
	libuuid.so.1 => /lib/libuuid.so.1 (0x0f2bd000)
	librt.so.1 => /lib/librt.so.1 (0x0f294000)
	libcrypt.so.1 => /lib/libcrypt.so.1 (0x0f243000)
	libbz2.so.1.0 => /lib/libbz2.so.1.0 (0x0f210000)
	/lib/ld.so.1 (0x203ec000)
	libexpat.so.1 => /usr/lib/libexpat.so.1 (0x0f1c2000)
Terminal: screen
$DISPLAY not set.
`which aptitude`: /usr/bin/aptitude
aptitude version information:

aptitude linkage:

-- System Information:
Debian Release: squeeze/sid
  APT prefers testing
  APT policy: (500, 'testing'), (200, 'unstable')
Architecture: powerpc (ppc)

Kernel: Linux 2.6.30-2-powerpc
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages aptitude depends on:
ii  apt [libapt-pkg-libc6. 0.7.24            Advanced front-end for dpkg
ii  libboost-iostreams1.40 1.40.0-2          Boost.Iostreams Library
ii  libc6                  2.10.1-7          GNU C Library: Shared libraries
ii  libcwidget3            0.5.13-1          high-level terminal interface libr
ii  libept0                0.5.29            High-level library for managing De
ii  libgcc1                1:4.4.1-4         GCC support library
ii  liblog4cxx10           0.10.0-1          A logging library for C++
ii  libncursesw5           5.7+20090803-2    shared libraries for terminal hand
ii  libsigc++-2.0-0c2a     2.0.18-2          type-safe Signal Framework for C++
ii  libsqlite3-0           3.6.20-1          SQLite 3 shared library
ii  libstdc++6             4.4.1-4           The GNU Standard C++ Library v3
ii  libxapian15            1.0.16-3          Search engine library
ii  zlib1g                 1:1.2.3.3.dfsg-15 compression library - runtime

Versions of packages aptitude recommends:
pn  apt-xapian-index              <none>     (no description available)
pn  aptitude-doc-en | aptitude-do <none>     (no description available)
pn  libparse-debianchangelog-perl <none>     (no description available)
ii  sensible-utils                0.0.1      Utilities for sensible alternative

Versions of packages aptitude suggests:
pn  debtags                       <none>     (no description available)
ii  tasksel                       2.80       Tool for selecting tasks for insta

-- no debconf information

[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#557580; Package aptitude. (Mon, 23 Nov 2009 01:48:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Burrows <dburrows@debian.org>:
Extra info received and forwarded to list. (Mon, 23 Nov 2009 01:48:06 GMT) Full text and rfc822 format available.

Message #10 received at 557580@bugs.debian.org (full text, mbox):

From: Daniel Burrows <dburrows@debian.org>
To: Daniel Kahn Gillmor <dkg@fifthhorseman.net>, 557580@bugs.debian.org
Subject: Re: Bug#557580: aptitude accepts /etc/apt/preferences but ignores /etc/apt/preferences.d/*
Date: Sun, 22 Nov 2009 17:44:22 -0800
  aptitude has its own replacement for pkgCacheFile that it uses to
initialize itself.  Arguably this is bad; on the other hand, it seems
to be the only way to create a subclass of pkgDepCache during startup
instead of creating a straight pkgDepCache.

  Anyway, it looks like the code to read the policy pin directory was
placed into pkgCacheFile.  I guess this is now part of the "official"
startup ritual for apt.  I still don't see a good way to use
pkgCacheFile, unless I'm willing to create a junk pkgDepCache and throw
it away (very expensive).  I can't even change to using a proxy for the
real DepCache, because I need to subclass it in order to configure its
behavior.  :-(

  So, I guess I'll just update the cut&paste job.  Yuck.

  Daniel




Information forwarded to debian-bugs-dist@lists.debian.org, Daniel Burrows <dburrows@debian.org>:
Bug#557580; Package aptitude. (Mon, 23 Nov 2009 03:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Kahn Gillmor <dkg@fifthhorseman.net>:
Extra info received and forwarded to list. Copy sent to Daniel Burrows <dburrows@debian.org>. (Mon, 23 Nov 2009 03:42:03 GMT) Full text and rfc822 format available.

Message #15 received at 557580@bugs.debian.org (full text, mbox):

From: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
To: Daniel Burrows <dburrows@debian.org>
Cc: 557580@bugs.debian.org
Subject: Re: Bug#557580: aptitude accepts /etc/apt/preferences but ignores /etc/apt/preferences.d/*
Date: Sun, 22 Nov 2009 22:37:11 -0500
[Message part 1 (text/plain, inline)]
On 11/22/2009 08:44 PM, Daniel Burrows wrote (about debian #557580):
>   So, I guess I'll just update the cut&paste job.  Yuck.

ugh indeed.  i've got no better suggestions, unfortunately, and you know
the apt/aptitude internals far better than i do.  Perhaps it's worth
opening a bug on apt or apt-utils (or passing #557580 off to the right
package) to try to resolve some of the pkgCacheFile inheritance issues
you've outlined here?  They do sound ugly.

Thanks again for your work on aptitude, Daniel.

	--dkg

[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Daniel Burrows <dburrows@debian.org>:
Bug#557580; Package aptitude. (Sun, 06 Jun 2010 13:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jamie McClelland <jm@mayfirst.org>:
Extra info received and forwarded to list. Copy sent to Daniel Burrows <dburrows@debian.org>. (Sun, 06 Jun 2010 13:30:03 GMT) Full text and rfc822 format available.

Message #20 received at 557580@bugs.debian.org (full text, mbox):

From: Jamie McClelland <jm@mayfirst.org>
To: 557580@bugs.debian.org
Subject: progress on aptitude ignoring preferences.d?
Date: Sun, 6 Jun 2010 09:18:26 -0400
[Message part 1 (text/plain, inline)]
Has any progress been made on fixing aptitude so it properly respects
files in preferences.d?

I've noticed this behavoir with aptitude 0.61.5-3.

Thanks!

jamie

0 robideau:~# dpkg -l aptitude
Desired=Unknown/Install/Remove/Purge/Hold
| Status=Not/Inst/Conf-files/Unpacked/halF-conf/Half-inst/trig-aWait/Trig-pend
|/ Err?=(none)/Reinst-required (Status,Err: uppercase=bad)
||/ Name           Version        Description
+++-==============-==============-============================================
ii  aptitude       0.6.1.5-3      terminal-based package manager (terminal int
0 robideau:~# cat /etc/apt/preferences.d/rdiff-backup 
Package: rdiff-backup
Pin: release a=stable
Pin-Priority: 999
0 robideau:~# apt-cache policy rdiff-backup
rdiff-backup:
  Installed: 1.2.5-1
  Candidate: 1.2.5-1
  Package pin: 1.2.5-1
  Version table:
     1.2.8-6 999
        500 http://ftp.us.debian.org squeeze/main Packages
 *** 1.2.5-1 999
        500 http://ftp.us.debian.org lenny/main Packages
        100 /var/lib/dpkg/status
0 robideau:~# aptitude dist-upgrade
Reading package lists... Done
Building dependency tree       
Reading state information... Done
Reading extended state information... Done
Initializing package states... Done       
Reading task descriptions... Done  
The following packages will be upgraded:
  rdiff-backup 
1 packages upgraded, 0 newly installed, 0 to remove and 0 not upgraded.
Need to get 0B/202kB of archives. After unpacking 41.0kB will be used.
Do you want to continue? [Y/n/?] n
Abort.
0 robideau:~#

[signature.asc (application/pgp-signature, inline)]

Forcibly Merged 557580 571312. Request was from martin f krafft <madduck@debian.org> to control@bugs.debian.org. (Mon, 16 Aug 2010 06:00:06 GMT) Full text and rfc822 format available.

Severity set to 'important' from 'normal' Request was from martin f. krafft <madduck@debian.org> to control@bugs.debian.org. (Mon, 16 Aug 2010 06:03:03 GMT) Full text and rfc822 format available.

Information stored :
Bug#557580; Package aptitude. (Mon, 16 Aug 2010 06:03:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to martin f krafft <madduck@debian.org>:
Extra info received and filed, but not forwarded. (Mon, 16 Aug 2010 06:03:06 GMT) Full text and rfc822 format available.

Message #29 received at 557580-quiet@bugs.debian.org (full text, mbox):

From: martin f krafft <madduck@debian.org>
To: 557580-quiet@bugs.debian.org
Subject: Re: Bug#571312: aptitude ignores preferences.d directory
Date: Mon, 16 Aug 2010 08:02:01 +0200
[Message part 1 (text/plain, inline)]
Daniel, I would like to make ths RC, since preferences.d is
documented in apt_preferences(5) as a integral aspect of APT, which
aptitude does not obey. Hence this may well cause problems on
systems (remember that we do not support downgrades). Thoughts?

-- 
 .''`.   martin f. krafft <madduck@d.o>      Related projects:
: :'  :  proud Debian developer               http://debiansystem.info
`. `'`   http://people.debian.org/~madduck    http://vcs-pkg.org
  `-  Debian - when you have better things to do than fixing systems
[digital_signature_gpg.asc (application/pgp-signature, inline)]

Changed Bug title to 'aptitude does not obey pins in preferences.d/*' from 'aptitude accepts /etc/apt/preferences but ignores /etc/apt/preferences.d/*' Request was from martin f. krafft <madduck@debian.org> to control@bugs.debian.org. (Mon, 16 Aug 2010 06:06:03 GMT) Full text and rfc822 format available.

Severity set to 'serious' from 'important' Request was from martin f. krafft <madduck@debian.org> to control@bugs.debian.org. (Wed, 08 Sep 2010 05:27:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Daniel Burrows <dburrows@debian.org>:
Bug#557580; Package aptitude. (Tue, 12 Oct 2010 22:24:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tim Retout <diocles@debian.org>:
Extra info received and forwarded to list. Copy sent to Daniel Burrows <dburrows@debian.org>. (Tue, 12 Oct 2010 22:24:03 GMT) Full text and rfc822 format available.

Message #38 received at 557580@bugs.debian.org (full text, mbox):

From: Tim Retout <diocles@debian.org>
To: 557580@bugs.debian.org
Subject: Re: Bug#557580: aptitude does not obey pins in preferences.d/*
Date: Tue, 12 Oct 2010 23:21:35 +0100
[Message part 1 (text/plain, inline)]
tags 557580 patch
thanks

I have built a package with the following patch, and it seems to work.
I would appreciate some code review from someone with experience of the
aptitude code base.

(I haven't checked what calls the dump_packages.cc code, but it seemed
like a good idea to update that as well.)

If I don't hear anything by the time I've convinced myself the patch is
correct, I'll upload a delayed NMU for this bug and #594505.


--- aptitude-0.6.3.orig/src/generic/apt/aptcache.cc
+++ aptitude-0.6.3/src/generic/apt/aptcache.cc
@@ -2179,7 +2179,7 @@ bool aptitudeCacheFile::Open(OpProgress
   Policy=new aptitudePolicy(Cache);
   if(_error->PendingError())
     return false;
-  if(!ReadPinFile(*Policy))
+  if(ReadPinFile(*Policy) == false || ReadPinDir(*Policy) == false)
     return false;

   DCache=new aptitudeDepCache(Cache, Policy);
--- aptitude-0.6.3.orig/src/generic/apt/dump_packages.cc
+++ aptitude-0.6.3/src/generic/apt/dump_packages.cc
@@ -744,6 +744,7 @@ namespace aptitude
     //   $(Dir::Etc::main)
     //   $(Dir::Etc::parts)/*
     //   $(Dir::Etc::preferences)
+    //   $(Dir::Etc::preferencesparts)/*
     //
     // Dir::State::* are truncated copies; the others are copied
     // literally.
@@ -837,6 +838,12 @@ namespace aptitude
          copy_truncated(preferences, outDir + "/" + preferences,
                         visited_packages);
       }
+
+      {
+       const std::string preferencesParts = _config->FindDir("Dir::Etc::preferencesparts");
+       if(!preferencesParts.empty())
+         recursive_copy_dir(preferencesParts, outDir + "/" + preferencesParts);
+      }
     }

     void dump_truncated_packages(const std::set<pkgCache::PkgIterator> &packages,


Regards,

-- 
Tim Retout <diocles@debian.org>
[signature.asc (application/pgp-signature, inline)]

Added tag(s) patch. Request was from Tim Retout <diocles@debian.org> to control@bugs.debian.org. (Tue, 12 Oct 2010 22:33:02 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Daniel Burrows <dburrows@debian.org>:
Bug#557580; Package aptitude. (Wed, 13 Oct 2010 17:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to David Kalnischkies <kalnischkies+debian@gmail.com>:
Extra info received and forwarded to list. Copy sent to Daniel Burrows <dburrows@debian.org>. (Wed, 13 Oct 2010 17:57:03 GMT) Full text and rfc822 format available.

Message #45 received at 557580@bugs.debian.org (full text, mbox):

From: David Kalnischkies <kalnischkies+debian@gmail.com>
To: 557580@bugs.debian.org
Subject: Re: aptitude does not obey pins in preferences.d/*
Date: Wed, 13 Oct 2010 19:54:06 +0200
> Anyway, it looks like the code to read the policy pin directory was
> placed into pkgCacheFile.  I guess this is now part of the "official"
> startup ritual for apt.  I still don't see a good way to use
> pkgCacheFile, unless I'm willing to create a junk pkgDepCache and throw
> it away (very expensive).  I can't even change to using a proxy for the
> real DepCache, because I need to subclass it in order to configure its
> behavior.  :-(

I had rewritten pkgCacheFile for my needs recently, maybe it is now
possible to subclass pkgCacheFile and replace the BuildDepCache
method for your needs, too?


Just ignore me if i am wrong, i just stumbled across Tim Retout blogpost
about this bug and remembered #535512. I haven't even looked to deep
at the code as i can't test a patch anyway (compiling aptitudes needs more
or less hours to build and i have just a few minutes currently…).


Best regards

David Kalnischkies




Information forwarded to debian-bugs-dist@lists.debian.org, Daniel Burrows <dburrows@debian.org>:
Bug#557580; Package aptitude. (Sat, 16 Oct 2010 21:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tim Retout <diocles@debian.org>:
Extra info received and forwarded to list. Copy sent to Daniel Burrows <dburrows@debian.org>. (Sat, 16 Oct 2010 21:42:03 GMT) Full text and rfc822 format available.

Message #50 received at 557580@bugs.debian.org (full text, mbox):

From: Tim Retout <diocles@debian.org>
To: 557580@bugs.debian.org
Subject: Re: Bug#557580: aptitude does not obey pins in preferences.d/*
Date: Sat, 16 Oct 2010 22:41:11 +0100
[Message part 1 (text/plain, inline)]
I have made one extra change in the NMU; I added ReadPinDir next to
ReadPinFile in src/cmdline/cmdline_do_action.cc as well.

The final NMU diff is in bug #600410.

-- 
Tim Retout <diocles@debian.org>
[signature.asc (application/pgp-signature, inline)]

Added tag(s) pending. Request was from Tim Retout <diocles@debian.org> to control@bugs.debian.org. (Sat, 16 Oct 2010 23:15:03 GMT) Full text and rfc822 format available.

Reply sent to Tim Retout <diocles@debian.org>:
You have taken responsibility. (Mon, 18 Oct 2010 21:51:12 GMT) Full text and rfc822 format available.

Notification sent to Daniel Kahn Gillmor <dkg@fifthhorseman.net>:
Bug acknowledged by developer. (Mon, 18 Oct 2010 21:51:12 GMT) Full text and rfc822 format available.

Message #57 received at 557580-close@bugs.debian.org (full text, mbox):

From: Tim Retout <diocles@debian.org>
To: 557580-close@bugs.debian.org
Subject: Bug#557580: fixed in aptitude 0.6.3-3.2
Date: Mon, 18 Oct 2010 21:47:53 +0000
Source: aptitude
Source-Version: 0.6.3-3.2

We believe that the bug you reported is fixed in the latest version of
aptitude, which is due to be installed in the Debian FTP archive:

aptitude-dbg_0.6.3-3.2_amd64.deb
  to main/a/aptitude/aptitude-dbg_0.6.3-3.2_amd64.deb
aptitude-doc-cs_0.6.3-3.2_all.deb
  to main/a/aptitude/aptitude-doc-cs_0.6.3-3.2_all.deb
aptitude-doc-en_0.6.3-3.2_all.deb
  to main/a/aptitude/aptitude-doc-en_0.6.3-3.2_all.deb
aptitude-doc-es_0.6.3-3.2_all.deb
  to main/a/aptitude/aptitude-doc-es_0.6.3-3.2_all.deb
aptitude-doc-fi_0.6.3-3.2_all.deb
  to main/a/aptitude/aptitude-doc-fi_0.6.3-3.2_all.deb
aptitude-doc-fr_0.6.3-3.2_all.deb
  to main/a/aptitude/aptitude-doc-fr_0.6.3-3.2_all.deb
aptitude-doc-ja_0.6.3-3.2_all.deb
  to main/a/aptitude/aptitude-doc-ja_0.6.3-3.2_all.deb
aptitude-gtk_0.6.3-3.2_amd64.deb
  to main/a/aptitude/aptitude-gtk_0.6.3-3.2_amd64.deb
aptitude_0.6.3-3.2.debian.tar.gz
  to main/a/aptitude/aptitude_0.6.3-3.2.debian.tar.gz
aptitude_0.6.3-3.2.dsc
  to main/a/aptitude/aptitude_0.6.3-3.2.dsc
aptitude_0.6.3-3.2_amd64.deb
  to main/a/aptitude/aptitude_0.6.3-3.2_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 557580@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Tim Retout <diocles@debian.org> (supplier of updated aptitude package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Tue, 12 Oct 2010 21:11:54 +0100
Source: aptitude
Binary: aptitude aptitude-gtk aptitude-dbg aptitude-doc-cs aptitude-doc-en aptitude-doc-es aptitude-doc-fi aptitude-doc-fr aptitude-doc-ja
Architecture: source amd64 all
Version: 0.6.3-3.2
Distribution: unstable
Urgency: low
Maintainer: Daniel Burrows <dburrows@debian.org>
Changed-By: Tim Retout <diocles@debian.org>
Description: 
 aptitude   - terminal-based package manager (terminal interface only)
 aptitude-dbg - Debug symbols for the aptitude package manager
 aptitude-doc-cs - Czech manual for aptitude, a terminal-based package manager
 aptitude-doc-en - English manual for aptitude, a terminal-based package manager
 aptitude-doc-es - Spanish manual for aptitude, a terminal-based package manager
 aptitude-doc-fi - Finnish manual for aptitude, a terminal-based package manager
 aptitude-doc-fr - French manual for aptitude, a terminal-based package manager
 aptitude-doc-ja - Japanese manual for aptitude, a terminal-based package manager
 aptitude-gtk - terminal-based package manager (GUI and terminal interfaces)
Closes: 557580 594505
Changes: 
 aptitude (0.6.3-3.2) unstable; urgency=low
 .
   * Non-maintainer upload.
   * 0007-preferences-dir.patch: Patch to support /etc/apt/preferences.d/
     directory. (Closes: #557580)
   * debian/rules: Fix clean rule.  Patch by Stéphane Glondu.
     (Closes: #594505)
Checksums-Sha1: 
 cd288683d10a89a42eca0ad21934e99e64038be1 1677 aptitude_0.6.3-3.2.dsc
 d6d653aff6202d7546022556507f7ac5985d1c01 47475 aptitude_0.6.3-3.2.debian.tar.gz
 3a4cdae3de9691198b1c12af8c43af81823a49b9 3852372 aptitude_0.6.3-3.2_amd64.deb
 1b763f1c00d2d3180a6e626d5b11ee63c15e598f 2013094 aptitude-gtk_0.6.3-3.2_amd64.deb
 913242df6ad31826c4194f4212e1e795f2190c9c 24439496 aptitude-dbg_0.6.3-3.2_amd64.deb
 f335c512ae4f6335b08c1b9c82e4810908cce065 386162 aptitude-doc-cs_0.6.3-3.2_all.deb
 642fad597d10ec336dd7ccf87a667b39a066e6f5 455190 aptitude-doc-en_0.6.3-3.2_all.deb
 2267adb8acce76afa69efee0c44de1f8694b918f 481340 aptitude-doc-es_0.6.3-3.2_all.deb
 6acef86fe3062b9a2810ee9fd9951af10bfced69 277552 aptitude-doc-fi_0.6.3-3.2_all.deb
 7acc31acea10e54378494ef965c10500cf11c685 337356 aptitude-doc-fr_0.6.3-3.2_all.deb
 a2219884100da02b2bfaa953f31a64e1cfd628c7 401146 aptitude-doc-ja_0.6.3-3.2_all.deb
Checksums-Sha256: 
 8252be6b325af46e3b0021e12229fe5af58fdd01db23fc11a69b66eb12278d68 1677 aptitude_0.6.3-3.2.dsc
 579c76b10c48c70582562c0e5e540ee3f00ffc96b0c81723fbb02eaceea47e0e 47475 aptitude_0.6.3-3.2.debian.tar.gz
 b35b28bb035ca76dc9a6f73a917ec0fc9810548793e0735a2904c36910c76bf6 3852372 aptitude_0.6.3-3.2_amd64.deb
 a273a1c71582e2e878f860e4b8c0b332fa42edd0c5df457ea2606dcb238f9b0a 2013094 aptitude-gtk_0.6.3-3.2_amd64.deb
 31198ee37fd2e6eddae44586d0c3115c9b21ce8cbf54a0212a967efb2cf0de9b 24439496 aptitude-dbg_0.6.3-3.2_amd64.deb
 dbc0391050ae0eba7cd6614a81e4388513f29cd394e8a8e182caa7c7d37e834e 386162 aptitude-doc-cs_0.6.3-3.2_all.deb
 77ff3935fdbb144f6ae0447c3eeed2fb644b4ada7a4157b04be9e64688394634 455190 aptitude-doc-en_0.6.3-3.2_all.deb
 2c52bb26bca90921ad00d6724c97010281edd564e9c1736cce8e73c7de810786 481340 aptitude-doc-es_0.6.3-3.2_all.deb
 ac08dd8c7ee12c44983456b61104ffc0568a9ee61c367e5574fa17a33f65f71a 277552 aptitude-doc-fi_0.6.3-3.2_all.deb
 ac9b73829548a0b96d93a2844dfb1d0be3c1fb5795256b9105980206b0e5cd2c 337356 aptitude-doc-fr_0.6.3-3.2_all.deb
 9788ae5ffa869491088fce06e21dc4eac3644e269218bc997c46dda1f7a618bd 401146 aptitude-doc-ja_0.6.3-3.2_all.deb
Files: 
 69109bf125a1f3584923d17e7ce399ac 1677 admin - aptitude_0.6.3-3.2.dsc
 f9eb8947b43e25cb75a0581bbe29bcc3 47475 admin - aptitude_0.6.3-3.2.debian.tar.gz
 ef0563c1fe4e5bc2698f07fd49e7ddbe 3852372 admin important aptitude_0.6.3-3.2_amd64.deb
 688f96ddbc1381842277116d2e624353 2013094 admin optional aptitude-gtk_0.6.3-3.2_amd64.deb
 f6e129c9b7eb67f620938adc70665866 24439496 debug extra aptitude-dbg_0.6.3-3.2_amd64.deb
 c8eead5baf3e24b939ec7aa4d24e6c04 386162 doc optional aptitude-doc-cs_0.6.3-3.2_all.deb
 ed898aa6becb450c5b33cf6865a892bc 455190 doc optional aptitude-doc-en_0.6.3-3.2_all.deb
 4b2c12b218a3601d5eef6c807f48a2c3 481340 doc optional aptitude-doc-es_0.6.3-3.2_all.deb
 8a57743203638988614485b481736fe7 277552 doc optional aptitude-doc-fi_0.6.3-3.2_all.deb
 0efb0af569f31e67f62238166afcd572 337356 doc optional aptitude-doc-fr_0.6.3-3.2_all.deb
 904c87c682d7609c18426f9071c0345a 401146 doc optional aptitude-doc-ja_0.6.3-3.2_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAky6F+gACgkQOHNNd4eQFFJASQCfWzKuwRodvh7Y1jU2mykxl2/H
cJAAn0oLZtwDta94lI3wAP+fXQ1Y6dCh
=CKa8
-----END PGP SIGNATURE-----





Reply sent to Tim Retout <diocles@debian.org>:
You have taken responsibility. (Mon, 18 Oct 2010 21:51:12 GMT) Full text and rfc822 format available.

Notification sent to Dmitry Azhichakov <dmitry@dsa.pp.ru>:
Bug acknowledged by developer. (Mon, 18 Oct 2010 21:51:13 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 26 Nov 2010 07:31:26 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 07:05:40 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.